#! /bin/bash
# define delete_entry

delete_entry(){
delete_verb=$(yad --on-top --mouse --title "Delete $verb ... sure?" --button="Completely:3" --button="Delete from html:4")
ret=$?
if [[ $ret -eq 3 ]];then # Delete txt and html
rm -rf verbs-data/$verb.txt
# delete row of table with $verb, if it already exists
sed -i'.bak' '/'$verb'/d' verbs2.html
exit 0;
fi
if [[ $ret -eq 4 ]];then # Delete html
# delete row of table with $verb, if it already exists
sed -i'.bak' '/'$verb'/d' verbs2.html
exit 0;
fi
}

cd /root/verbs/Documents-on-tablet
verb=$(find verbs-data -type f -iname "*.txt" -printf "%f\n" | sort | sed 's/.txt//g' | awk '{printf "%s!", $1}')
echo $verb
dialog=$(yad --width=300 --on-top --mouse --title "Edit Text File" --form --field ":cb" "${verb%%!}" --button="gtk-ok:0")
ret=$?
if [[ $ret -ne 0 ]];then
exit 0
fi
verb=$(echo $dialog | awk 'BEGIN {FS="|" }{print $1}')
echo $verb
. verbs-data/$verb.txt
xmodmap -e "keycode 65 = underscore"
dialog=$(yad --mouse --title "$verb.txt ... change first field to export as something else" --form --width=1500 --columns=2 --selectable-labels \
--field='<b>verb</b>' \
--field='<b>eng</b>' \
--field='<span foreground="firebrick">pres-ind-eu</span>' \
--field='<span foreground="firebrick">pres-ind-tu</span>' \
--field='<span foreground="firebrick">pres-ind-ve</span>' \
--field='<span foreground="firebrick">pres-ind-ns</span>' \
--field='<span foreground="firebrick">pres-ind-vs</span>' \
--field='<span foreground="firebrick"><b>eng</b></span>' \
--field='pret-imp-eu' \
--field='pret-imp-tu' \
--field='pret-imp-ve' \
--field='pret-imp-ns' \
--field='pret-imp-vs' \
--field='<b>eng</b>' \
--field='<span foreground="firebrick">pret-ind-eu</span>' \
--field='<span foreground="firebrick">pret-ind-tu</span>' \
--field='<span foreground="firebrick">pret-ind-ve</span>' \
--field='<span foreground="firebrick">pret-ind-ns</span>' \
--field='<span foreground="firebrick">pret-ind-vs</span>' \
--field='<span foreground="firebrick"><b>eng</b></span>' \
--field='fut-ind-eu' \
--field='fut-ind-tu' \
--field='fut-ind-ve' \
--field='fut-ind-ns' \
--field='fut-ind-vs' \
--field='<b>eng</b>' \
--field='<span foreground="firebrick">fut-per-eu</span>' \
--field='<span foreground="firebrick">fut-per-tu</span>' \
--field='<span foreground="firebrick">fut-per-ve</span>' \
--field='<span foreground="firebrick">fut-per-ns</span>' \
--field='<span foreground="firebrick">fut-per-vs</span>' \
--field='<span foreground="firebrick"><b>eng</b></span>' \
--field='cond-eu' \
--field='cond-tu' \
--field='cond-ve' \
--field='cond-ns' \
--field='cond-vs' \
--field='<b>eng</b>' \
--field='<span foreground="firebrick">pret-sub-(se)-eu</span>' \
--field='<span foreground="firebrick">pret-sub-(se)-tu</span>' \
--field='<span foreground="firebrick">pret-sub-(se)-ve</span>' \
--field='<span foreground="firebrick">pret-sub-(se)-ns</span>' \
--field='<span foreground="firebrick">pret-sub-(se)-vs</span>' \
--field='<span foreground="firebrick"><b>eng</b></span>' \
--field='pres-sub-(que)-eu' \
--field='pres-sub-(que)-tu' \
--field='pres-sub-(que)-ve' \
--field='pres-sub-(que)-ns' \
--field='pres-sub-(que)-vs' \
--field='<b>eng</b>' \
--field='<span foreground="firebrick">fut-sub-(quando)-eu</span>' \
--field='<span foreground="firebrick">fut-sub-(quando)-tu</span>' \
--field='<span foreground="firebrick">fut-sub-(quando)-ve</span>' \
--field='<span foreground="firebrick">fut-sub-(quando)-ns</span>' \
--field='<span foreground="firebrick">fut-sub-(quando)-vs</span>' \
--field='<span foreground="firebrick"><b>eng</b></span>' \
"$v1" "$v2" \
"$v3" "$v4" "$v5" "$v6" "$v7" "$v8" \
"$v9" "$v10" "$v11" "$v12" "$v13" "$v14" \
"$v15" "$v16" "$v17" "$v18" "$v19" "$v20" \
"$v21" "$v22" "$v23" "$v24" "$v25" "$v26" \
"$v27" "$v28" "$v29" "$v30" "$v31" "$v32" \
"$v33" "$v34" "$v35" "$v36" "$v37" "$v38" \
"$v39" "$v40" "$v41" "$v42" "$v43" "$v44" \
"$v45" "$v46" "$v47" "$v48" "$v49" "$v50" \
"$v51" "$v52" "$v53" "$v54" "$v55" "$v56" \
--button="Delete:5" --button="New:6" --button="View:2" --button="Import:3" --button="Export:4" --button="gtk-ok:0" \
--field="<span foreground='blue'><b><big><big>à á â ã ç é ê í ó ô õ ú</big></big></b></span>:LBL")
ret=$?
if [[ $ret -eq 6 ]]; then
cp verbs-data/$verb.txt verbs-data/NEW.txt
# change first line of NEW.txt from 'v1=$verb' to 'v1=NEW'
sed -i "1s/.*/v1=NEW/" verbs-data/NEW.txt
fi
if [[ $ret -eq 2 ]]; then
geany verbs2.html verbs-data/$verb.txt
fi
if [[ $ret -eq 3 ]]; then
# create YAD combo box of all verbs in verbs2.html
readarray a < verbs2.html
# clear buffer std.txt
> std.txt
for element in "${a[@]}"
do
vbs=$(echo "$element" | awk 'BEGIN {FS="<tr><td>" }{print $2}' | awk 'BEGIN {FS="</td><td>" }{print $1}' | sort | awk '{printf "%s", $1}' | sed 's/<\/td><td//g')
# one by one extract verbs from verbs2.html
echo $vbs >> std.txt
done
# remove blank lines
sed -i '/^$/d' std.txt
# replace each newline with !
vb=$(tr '\n' '!' < std.txt)
# select a verb to import
dialog2=$(yad --on-top --mouse --width=500 --title "Import" --form --field ":cb" "${vb%%!}" --button="to $verb:0")
ret=$?
if [[ $ret -ne 0 ]];then
exit 0
fi
vsource=$(echo $dialog2 | awk 'BEGIN {FS="|" }{print $1}')

# test1:  vsource=$(echo "DAR")
table_row=$(awk '/'$vsource'/' verbs2.html)
echo $table_row
echo $table_row > verbs-data/$verb.txt
echo $vsource
echo $verb

sed -i "s|<tr><td>||g" verbs-data/$verb.txt

sed -i "s|</td><td>|\n|g" verbs-data/$verb.txt

sed -i "s|</td><td class=\"i\">|\n_irr_|g" verbs-data/$verb.txt

sed -i "s|</td></tr>|\n|g" verbs-data/$verb.txt

sed -i "s| |_|g" verbs-data/$verb.txt

awk '{printf("v%5d=%s\n", NR,$0)}' verbs-data/$verb.txt > tmp && mv tmp verbs-data/$verb.txt

sed -i "s| ||g" verbs-data/$verb.txt
# after clicking import button $verb.txt has new imported $vsource data
# first line of $verb.txt "v1=" defines $verb.txt filename to be written to
# first line must be $verb (old) not $vsource (new) for update to occur to $verb
sed -i "1s/$vsource/$verb/" verbs-data/$verb.txt
exit 0
fi
if [[ $ret -eq 5 ]]; then
delete_entry
exit 0
fi

if [[ $ret -eq 4 ]] || [[ $ret -eq 0 ]]; then
setxkbmap -layout gb
v1=$(echo $dialog | awk 'BEGIN {FS="|" }{print $1}') 
v2=$(echo $dialog | awk 'BEGIN {FS="|" }{print $2}') 
v3=$(echo $dialog | awk 'BEGIN {FS="|" }{print $3}') 
v4=$(echo $dialog | awk 'BEGIN {FS="|" }{print $4}') 
v5=$(echo $dialog | awk 'BEGIN {FS="|" }{print $5}') 
v6=$(echo $dialog | awk 'BEGIN {FS="|" }{print $6}') 
v7=$(echo $dialog | awk 'BEGIN {FS="|" }{print $7}') 
v8=$(echo $dialog | awk 'BEGIN {FS="|" }{print $8}') 
v9=$(echo $dialog | awk 'BEGIN {FS="|" }{print $9}') 
v10=$(echo $dialog | awk 'BEGIN {FS="|" }{print $10}') 
v11=$(echo $dialog | awk 'BEGIN {FS="|" }{print $11}') 
v12=$(echo $dialog | awk 'BEGIN {FS="|" }{print $12}') 
v13=$(echo $dialog | awk 'BEGIN {FS="|" }{print $13}') 
v14=$(echo $dialog | awk 'BEGIN {FS="|" }{print $14}') 
v15=$(echo $dialog | awk 'BEGIN {FS="|" }{print $15}') 
v16=$(echo $dialog | awk 'BEGIN {FS="|" }{print $16}') 
v17=$(echo $dialog | awk 'BEGIN {FS="|" }{print $17}') 
v18=$(echo $dialog | awk 'BEGIN {FS="|" }{print $18}') 
v19=$(echo $dialog | awk 'BEGIN {FS="|" }{print $19}') 
v20=$(echo $dialog | awk 'BEGIN {FS="|" }{print $20}') 
v21=$(echo $dialog | awk 'BEGIN {FS="|" }{print $21}') 
v22=$(echo $dialog | awk 'BEGIN {FS="|" }{print $22}') 
v23=$(echo $dialog | awk 'BEGIN {FS="|" }{print $23}') 
v24=$(echo $dialog | awk 'BEGIN {FS="|" }{print $24}') 
v25=$(echo $dialog | awk 'BEGIN {FS="|" }{print $25}') 
v26=$(echo $dialog | awk 'BEGIN {FS="|" }{print $26}') 
v27=$(echo $dialog | awk 'BEGIN {FS="|" }{print $27}') 
v28=$(echo $dialog | awk 'BEGIN {FS="|" }{print $28}') 
v29=$(echo $dialog | awk 'BEGIN {FS="|" }{print $29}') 
v30=$(echo $dialog | awk 'BEGIN {FS="|" }{print $30}') 
v31=$(echo $dialog | awk 'BEGIN {FS="|" }{print $31}') 
v32=$(echo $dialog | awk 'BEGIN {FS="|" }{print $32}') 
v33=$(echo $dialog | awk 'BEGIN {FS="|" }{print $33}') 
v34=$(echo $dialog | awk 'BEGIN {FS="|" }{print $34}') 
v35=$(echo $dialog | awk 'BEGIN {FS="|" }{print $35}') 
v36=$(echo $dialog | awk 'BEGIN {FS="|" }{print $36}') 
v37=$(echo $dialog | awk 'BEGIN {FS="|" }{print $37}') 
v38=$(echo $dialog | awk 'BEGIN {FS="|" }{print $38}') 
v39=$(echo $dialog | awk 'BEGIN {FS="|" }{print $39}') 
v40=$(echo $dialog | awk 'BEGIN {FS="|" }{print $40}') 
v41=$(echo $dialog | awk 'BEGIN {FS="|" }{print $41}') 
v42=$(echo $dialog | awk 'BEGIN {FS="|" }{print $42}') 
v43=$(echo $dialog | awk 'BEGIN {FS="|" }{print $43}') 
v44=$(echo $dialog | awk 'BEGIN {FS="|" }{print $44}') 
v45=$(echo $dialog | awk 'BEGIN {FS="|" }{print $45}') 
v46=$(echo $dialog | awk 'BEGIN {FS="|" }{print $46}') 
v47=$(echo $dialog | awk 'BEGIN {FS="|" }{print $47}') 
v48=$(echo $dialog | awk 'BEGIN {FS="|" }{print $48}') 
v49=$(echo $dialog | awk 'BEGIN {FS="|" }{print $49}') 
v50=$(echo $dialog | awk 'BEGIN {FS="|" }{print $50}') 
v51=$(echo $dialog | awk 'BEGIN {FS="|" }{print $51}') 
v52=$(echo $dialog | awk 'BEGIN {FS="|" }{print $52}') 
v53=$(echo $dialog | awk 'BEGIN {FS="|" }{print $53}') 
v54=$(echo $dialog | awk 'BEGIN {FS="|" }{print $54}') 
v55=$(echo $dialog | awk 'BEGIN {FS="|" }{print $55}') 
v56=$(echo $dialog | awk 'BEGIN {FS="|" }{print $56}') 
if [[ $ret -eq 4 ]]; then
# delete row of table with $verb, if it already exists
sed -i'.bak' '/'$verb'/d' verbs2.html
# temporarily remove last line </table></body></html>
dd if=/dev/null of=verbs2.html bs=1 seek=$(echo $(stat --format=%s verbs2.html ) - $( tail -n1 verbs2.html | wc -c) | bc )
# append exported verb
echo '<tr><td>'"$v1"'</td><td>'"$v2"'</td><td>'"$v3"'</td><td>'"$v4"'</td><td>'"$v5"'</td><td>'"$v6"'</td><td>'"$v7"'</td><td>'"$v8"'</td><td>'"$v9"'</td><td>'"$v10"'</td><td>'"$v11"'</td><td>'"$v12"'</td><td>'"$v13"'</td><td>'"$v14"'</td><td>'"$v15"'</td><td>'"$v16"'</td><td>'"$v17"'</td><td>'"$v18"'</td><td>'"$v19"'</td><td>'"$v20"'</td><td>'"$v21"'</td><td>'"$v22"'</td><td>'"$v23"'</td><td>'"$v24"'</td><td>'"$v25"'</td><td>'"$v26"'</td><td>'"$v27"'</td><td>'"$v28"'</td><td>'"$v29"'</td><td>'"$v30"'</td><td>'"$v31"'</td><td>'"$v32"'</td><td>'"$v33"'</td><td>'"$v34"'</td><td>'"$v35"'</td><td>'"$v36"'</td><td>'"$v37"'</td><td>'"$v38"'</td><td>'"$v39"'</td><td>'"$v40"'</td><td>'"$v41"'</td><td>'"$v42"'</td><td>'"$v43"'</td><td>'"$v44"'</td><td>'"$v45"'</td><td>'"$v46"'</td><td>'"$v47"'</td><td>'"$v48"'</td><td>'"$v49"'</td><td>'"$v50"'</td><td>'"$v51"'</td><td>'"$v52"'</td><td>'"$v53"'</td><td>'"$v54"'</td><td>'"$v55"'</td><td>'"$v56"'</td></tr>' | sed 's/<td>_irr_/<td class="i">/g' | sed 's/_/ /g' >> verbs2.html
# move it up the table and into alphabetical order
sed -e '/<tr><td>/,$d' verbs2.html > html-top.txt
sed -n '/<tr><td>/,$p' verbs2.html | sort > table-sorted.txt
cat html-top.txt table-sorted.txt > verbs2.html
echo '</table></body></html>' >> verbs2.html;
fi
if [[ -n $v1 ]]; then printf "v1=$v1%s\nv2=$v2%s\nv3=$v3%s\nv4=$v4%s\nv5=$v5%s\nv6=$v6%s\nv7=$v7%s\nv8=$v8%s\nv9=$v9%s\nv10=$v10%s\nv11=$v11%s\nv12=$v12%s\nv13=$v13%s\nv14=$v14%s\nv15=$v15%s\nv16=$v16%s\nv17=$v17%s\nv18=$v18%s\nv19=$v19%s\nv20=$v20%s\nv21=$v21%s\nv22=$v22%s\nv23=$v23%s\nv24=$v24%s\nv25=$v25%s\nv26=$v26%s\nv27=$v27%s\nv28=$v28%s\nv29=$v29%s\nv30=$v30%s\nv31=$v31%s\nv32=$v32%s\nv33=$v33%s\nv34=$v34%s\nv35=$v35%s\nv36=$v36%s\nv37=$v37%s\nv38=$v38%s\nv39=$v39%s\nv40=$v40%s\nv41=$v41%s\nv42=$v42%s\nv43=$v43%s\nv44=$v44%s\nv45=$v45%s\nv46=$v46%s\nv47=$v47%s\nv48=$v48%s\nv49=$v49%s\nv50=$v50%s\nv51=$v51%s\nv52=$v52%s\nv53=$v53%s\nv54=$v54%s\nv55=$v55%s\nv56=$v56" | sed 's/ /_/g' > verbs-data/"$v1".txt ;fi
find verbs-data -type f -iname "*.txt" -printf "%f\n" | sort > all-verbs.txt # all-verbs.txt is only for reference (not parsed)
else
setxkbmap -layout gb
fi